package com.loafle.overflow.model.history;

import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.member.Member;
import com.loafle.overflow.model.meta.MetaHistoryType;
import com.loafle.overflow.model.probe.Probe;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "HISTORY", schema = "public")
public class History {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  @ManyToOne
  @JoinColumn(name = "META_HISTORY_TYPE_ID", nullable = false)
  private MetaHistoryType metaHistoryType;

  @Column(name = "MESSAGE", nullable = false, length = 255)
  private String message;

  @ManyToOne
  @JoinColumn(name = "PROBE_ID", nullable = false)
  private Probe probe;

  @ManyToOne
  @JoinColumn(name = "MEMBER_ID", nullable = false)
  private Member member;

  @ManyToOne
  @JoinColumn(name = "DOMAIN_ID", nullable = false)
  private Domain domain;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public MetaHistoryType getMetaHistoryType() {
    return metaHistoryType;
  }

  public void setMetaHistoryType(MetaHistoryType metaHistoryType) {
    this.metaHistoryType = metaHistoryType;
  }

  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public Probe getProbe() {
    return probe;
  }

  public void setProbe(Probe probe) {
    this.probe = probe;
  }

  public Member getMember() {
    return member;
  }

  public void setMember(Member member) {
    this.member = member;
  }

  public Domain getDomain() {
    return domain;
  }

  public void setDomain(Domain domain) {
    this.domain = domain;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o)
      return true;
    if (o == null || getClass() != o.getClass())
      return false;

    History that = (History) o;

    if (id != that.id)
      return false;
    if (createDate != null ? !createDate.equals(that.createDate) : that.createDate != null)
      return false;

    return true;
  }

  @Override
  public int hashCode() {
    int result = (int) (id ^ (id >>> 32));
    result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
    return result;
  }
}
