package com.loafle.overflow.model.infra;

import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.model.probe.Probe;
import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "INFRA", schema = "public")
@Inheritance(strategy = InheritanceType.JOINED)
@DiscriminatorColumn(name = "INFRA_TYPE", discriminatorType = DiscriminatorType.INTEGER)
public abstract class Infra {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @ManyToOne
  @JoinColumn(name = "META_INFRA_TYPE_ID", nullable = false)
  private MetaInfraType metaInfraType;

  @ManyToOne
  @JoinColumn(name = "PROBE_ID", nullable = false)
  private Probe probe;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  protected Infra() {

  }

  protected Infra(Long id) {
    this.id = id;
  }

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public MetaInfraType getMetaInfraType() {
    return metaInfraType;
  }

  public void setMetaInfraType(MetaInfraType metaInfraType) {
    this.metaInfraType = metaInfraType;
  }

  public Probe getProbe() {
    return probe;
  }

  public void setProbe(Probe probe) {
    this.probe = probe;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }
}
