package com.loafle.overflow.model.infra;

import javax.persistence.*;

import com.loafle.overflow.model.meta.MetaIPType;
import com.loafle.overflow.model.meta.MetaTargetZoneType;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "INFRA_ZONE", schema = "public")
@DiscriminatorValue("1")
public class InfraZone extends Infra {

  @ManyToOne
  @JoinColumn(name = "META_TARGET_ZONE_TYPE_ID", nullable = true)
  private MetaTargetZoneType metaTargetZoneType;

  @ManyToOne
  @JoinColumn(name = "META_IP_TYPE_ID", nullable = true)
  private MetaIPType metaIPType;

  @Basic
  @Column(name = "NETWORK", nullable = true)
  private String network;

  @Basic
  @Column(name = "IFACE", nullable = true)
  private String iface;

  @Basic
  @Column(name = "ADDRESS", nullable = true)
  private String address;

  @Basic
  @Column(name = "MAC", nullable = true)
  private String mac;

  public InfraZone() {
    super();
  }

  public InfraZone(Long id) {
    super(id);
  }

  public MetaTargetZoneType getMetaTargetZoneType() {
    return metaTargetZoneType;
  }

  public void setMetaTargetZoneType(MetaTargetZoneType metaTargetZoneType) {
    this.metaTargetZoneType = metaTargetZoneType;
  }

  public String getNetwork() {
    return network;
  }

  public void setNetwork(String network) {
    this.network = network;
  }

  public String getIface() {
    return iface;
  }

  public void setIface(String iface) {
    this.iface = iface;
  }

  public MetaIPType getMetaIPType() {
    return metaIPType;
  }

  public void setMetaIPType(MetaIPType metaIPType) {
    this.metaIPType = metaIPType;
  }

  public String getAddress() {
    return address;
  }

  public void setAddress(String address) {
    this.address = address;
  }

  public String getMac() {
    return mac;
  }

  public void setMac(String mac) {
    this.mac = mac;
  }

}
