package com.loafle.overflow.model.member;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by geek on 18. 3. 8.
 */
@Entity
@Table(name = "MEMBER_TOTP", schema = "public")
public class MemberTotp {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @OneToOne
  @JoinColumn(name = "MEMBER_ID", nullable = false)
  private Member member;

  @Basic
  @Column(name = "SECRET_CODE", nullable = false, length = 20)
  private String secretCode;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "UPDATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = true)
  private Date updateDate;

  @Transient
  private String otpAuth;

  public MemberTotp() {
  }

  public MemberTotp(Long id) {
    this.id = id;
  }

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public Member getMember() {
    return member;
  }

  public void setMember(Member member) {
    this.member = member;
  }

  public String getSecretCode() {
    return secretCode;
  }

  public void setSecretCode(String secretCode) {
    this.secretCode = secretCode;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public Date getUpdateDate() {
    return updateDate;
  }

  public void setUpdateDate(Date updateDate) {
    this.updateDate = updateDate;
  }

  public String getOtpAuth() {
    return otpAuth;
  }

  public void setOtpAuth(String otpAuthURL) {
    this.otpAuth = otpAuthURL;
  }
}
