package com.loafle.overflow.model.meta;

import java.util.Date;

import javax.persistence.*;

/**
 * Created by snoop on 18. 4. 24.
 */
@Entity
@Table(name = "META_DISPLAY_ITEM_MAPPING", schema = "public")
public class MetaDisplayItemMapping {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @ManyToOne
  @JoinColumn(name = "META_DISPLAY_ITEM_ID", nullable = false)
  private MetaDisplayItem metaDisplayItem;

  @ManyToOne
  @JoinColumn(name = "META_CRAWLER_MAPPING_ID", nullable = false)
  private MetaCrawlerMapping metaCrawlerMapping;

  @ManyToOne
  @JoinColumn(name = "META_ITEM_UNIT_ID", nullable = true)
  private MetaItemUnit metaItemUnit;

  @ManyToOne
  @JoinColumn(name = "META_DISPLAY_ITEM_CATEGORY_ID", nullable = true)
  private MetaDisplayItemCategory metaDisplayItemCategory;

  @Column(name = "IS_DEFAULT", nullable = false, columnDefinition = "Boolean default false")
  private Boolean isDefault;

  @Column(name = "FORMULA", nullable = true)
  private String formula;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  @Column(name = "PRIORITY", nullable = true)
  private int priority;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public MetaDisplayItem getMetaDisplayItem() {
    return metaDisplayItem;
  }

  public void setMetaDisplayItem(MetaDisplayItem metaDisplayItem) {
    this.metaDisplayItem = metaDisplayItem;
  }

  public MetaCrawlerMapping getMetaCrawlerMapping() {
    return metaCrawlerMapping;
  }

  public void setMetaCrawlerMapping(MetaCrawlerMapping metaCrawlerMapping) {
    this.metaCrawlerMapping = metaCrawlerMapping;
  }

  public MetaItemUnit getMetaItemUnit() {
    return metaItemUnit;
  }

  public void setMetaItemUnit(MetaItemUnit metaItemUnit) {
    this.metaItemUnit = metaItemUnit;
  }

  public Boolean getDefault() {
    return isDefault;
  }

  public void setDefault(Boolean aDefault) {
    isDefault = aDefault;
  }

  public String getFormula() {
    return formula;
  }

  public void setFormula(String formula) {
    this.formula = formula;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public Integer getPriority() {
    return this.priority;
  }

  public void setPriority(Integer priority) {
    this.priority = priority;
  }
}
