package com.loafle.overflow.model.notification;

import com.loafle.overflow.model.member.Member;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by insanity on 17. 8. 25.
 */
@Entity
@Table(name = "NOTIFICATION", schema = "public")
public class Notification {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @Column(name = "TITLE", nullable = false, length = 50)
  private String title;

  @Column(name = "MESSAGE", nullable = false, length = 255)
  private String message;

  @ManyToOne
  @JoinColumn(name = "MEMBER_ID", nullable = false)
  private Member member;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CONFIRM_DATE", nullable = true)
  private Date confirmDate;

  @Column(name = "URL", nullable = false, length = 255)
  private String url;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public Member getMember() {
    return member;
  }

  public void setMember(Member member) {
    this.member = member;
  }

  public Date getConfirmDate() {
    return confirmDate;
  }

  public void setConfirmDate(Date confirmDate) {
    this.confirmDate = confirmDate;
  }

  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }
}
