package com.loafle.overflow.model.target;

import javax.persistence.*;

import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.meta.MetaTargetStatus;
import com.loafle.overflow.model.meta.MetaTargetType;
import com.loafle.overflow.model.sensor.Sensor;

import java.util.Date;
import java.util.List;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "TARGET", schema = "public")
public class Target {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @OneToOne
  @JoinColumn(name = "INFRA_ID", nullable = false)
  private Infra infra;

  @ManyToOne
  @JoinColumn(name = "META_TARGET_TYPE_ID", nullable = false)
  private MetaTargetType metaTargetType;

  @Column(name = "NAME")
  private String name;

  @Column(name = "DESCRIPTION")
  private String description;

  @Column(name = "SENSOR_COUNT", nullable = false)
  private Integer sensorCount;

  @ManyToOne
  @JoinColumn(name = "META_TARGET_STATUS_ID", nullable = false)
  private MetaTargetStatus metaTargetStatus;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  @Transient
  private List<Sensor> sensors;

  public Long getId() {
    return id;
  }

  public MetaTargetStatus getMetaTargetStatus() {
    return metaTargetStatus;
  }

  public void setMetaTargetStatus(MetaTargetStatus metaTargetStatus) {
    this.metaTargetStatus = metaTargetStatus;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Integer getSensorCount() {
    return sensorCount;
  }

  public void setSensorCount(Integer sensorCount) {
    this.sensorCount = sensorCount;
  }

  public List<Sensor> getSensors() {
    return sensors;
  }

  public void setSensors(List<Sensor> sensors) {
    this.sensors = sensors;
  }

  @PrePersist
  void preInsert() {
    this.sensorCount = 0;
  }

  public Infra getInfra() {
    return infra;
  }

  public void setInfra(Infra infra) {
    this.infra = infra;
  }

  public MetaTargetType getMetaTargetType() {
    return metaTargetType;
  }

  public void setMetaTargetType(MetaTargetType metaTargetType) {
    this.metaTargetType = metaTargetType;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }
}
