package com.loafle.overflow.service.central.sensor;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaDisplayItemMapping;
import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.target.Target;

import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface SensorService {
  @WebappAPI
  Sensor regist(Sensor sensor, List<MetaDisplayItemMapping> metaDisplayItemMappings) throws OverflowException;

  @WebappAPI
  Sensor modify(Long sensorID, List<MetaDisplayItemMapping> metaDisplayItemMappings) throws OverflowException;

  @WebappAPI
  Sensor read(Long id) throws OverflowException;

  @WebappAPI
  void remove(Long id) throws OverflowException;

  @WebappAPI
  List<Sensor> readAll() throws OverflowException;

  @WebappAPI
  List<Sensor> readAllByTargetID(Long targetID) throws OverflowException;

  @WebappAPI
  List<Sensor> readAllByTargetIn(List<Target> targets) throws OverflowException;

  @WebappAPI
  List<Sensor> readAllByTargetInfraProbeID(Long probeID) throws OverflowException;
}
